Utility functions to deal with serial ports

## Files

file | serial.h
file | serial.c

## Macros

#define | dbg_perror(x) do { } while (0)

## Functions

int | osmo_serial_init (const char *dev, speed_t baudrate)
| Open serial device and does base init. More...
int | osmo_serial_set_baudrate (int fd, speed_t baudrate)
| Change current baudrate. More...
int | osmo_serial_set_custom_baudrate (int fd, int baudrate)
| Change current baudrate to a custom one using OS specific method. More...
int | osmo_serial_clear_custom_baudrate (int fd)
| Clear any custom baudrate. More...
static int | _osmo_serial_set_baudrate (int fd, speed_t baudrate)

## Detailed Description

Osmocom serial port helpers

## Macro Definition Documentation

## dbg_perror

#define dbg_perror | ( |  | x | ) | do { } while (0)

## Function Documentation

## _osmo_serial_set_baudrate()

static int _osmo_serial_set_baudrate | ( | int | fd,
|  | speed_t | baudrate
| ) |  |

static

References dbg_perror.

Referenced by osmo_serial_set_baudrate(), and osmo_serial_set_custom_baudrate().

## osmo_serial_clear_custom_baudrate()

int osmo_serial_clear_custom_baudrate | ( | int | fd | ) |

Clear any custom baudrate.

Parameters

  [in] | fd | File descriptor of the open device

Returns
  0 for success or negative errno.

This function might not work on all OS or with all type of serial adapters

References dbg_perror.

Referenced by osmo_serial_set_baudrate().

## osmo_serial_init()

int osmo_serial_init | ( | const char * | dev,
|  | speed_t | baudrate
| ) |  |

Open serial device and does base init.

Parameters

  [in] | dev | Path to the device node to open
  [in] | baudrate | Baudrate constant (speed_t: B9600, B...)

Returns
  >=0 file descriptor in case of success or negative errno.

References dbg_perror.

## osmo_serial_set_baudrate()

int osmo_serial_set_baudrate | ( | int | fd,
|  | speed_t | baudrate
| ) |  |

Change current baudrate.

Parameters

  [in] | fd | File descriptor of the open device
  [in] | baudrate | Baudrate constant (speed_t: B9600, B...)

Returns
  0 for success or negative errno.

References _osmo_serial_set_baudrate(), and osmo_serial_clear_custom_baudrate().

## osmo_serial_set_custom_baudrate()

int osmo_serial_set_custom_baudrate | ( | int | fd,
|  | int | baudrate
| ) |  |

Change current baudrate to a custom one using OS specific method.

Parameters

  [in] | fd | File descriptor of the open device
  [in] | baudrate | Baudrate as integer

Returns
  0 for success or negative errno.

This function might not work on all OS or with all type of serial adapters

References _osmo_serial_set_baudrate(), and dbg_perror.